aboutsummaryrefslogtreecommitdiffstats
path: root/bootscripts/contrib/lsb-v3/etc/init.d/checkfs
diff options
context:
space:
mode:
authorDJ Lucas <dj@linuxfromscratch.org>2011-05-14 19:41:18 +0000
committerDJ Lucas <dj@linuxfromscratch.org>2011-05-14 19:41:18 +0000
commitcb95d5f23b3c5b803f83a38f09d654bd9924f421 (patch)
treeabd65023fedb4c995ad741b53c3b1606faba46a0 /bootscripts/contrib/lsb-v3/etc/init.d/checkfs
parent03bf43c6eab6a31a2e43aa1bd48ff375f5e04173 (diff)
Changed distribution directory structure.
git-svn-id: http://svn.linuxfromscratch.org/LFS/trunk/BOOK@9530 4aa44e1e-78dd-0310-a6d2-fbcd4c07a689
Diffstat (limited to 'bootscripts/contrib/lsb-v3/etc/init.d/checkfs')
-rw-r--r--bootscripts/contrib/lsb-v3/etc/init.d/checkfs103
1 files changed, 103 insertions, 0 deletions
diff --git a/bootscripts/contrib/lsb-v3/etc/init.d/checkfs b/bootscripts/contrib/lsb-v3/etc/init.d/checkfs
new file mode 100644
index 000000000..1e3efed9b
--- /dev/null
+++ b/bootscripts/contrib/lsb-v3/etc/init.d/checkfs
@@ -0,0 +1,103 @@
+#!/bin/sh
+# Begin /etc/init.d/checkfs
+
+### BEGIN INIT INFO
+# Provides: checkfs
+# Required-Start: udev swap
+# Should-Start:
+# Required-Stop:
+# Should-Stop:
+# Default-Start: S
+# Default-Stop:
+# Short-Description: Checks local filesystems before mounting.
+# Description: Checks local filesystmes before mounting.
+# X-LFS-Provided-By: LFS
+### END INIT INFO
+
+. /lib/lsb/init-functions
+
+case "${1}" in
+ start)
+ if [ -f /fastboot ]; then
+ echo "${INFO}/fastboot found!"
+ log_success_msg "Will not perform file system checks as requested."
+ exit 0
+ fi
+
+ mount -n -o remount,ro / >/dev/null
+ if [ ${?} -ne 0 ]
+ then
+ log_failure_msg "Mounting root file system in read-only mode"
+ echo -e "${FAILURE}FAILURE:\n"
+ echo -e -n "${FAILURE}Cannot check root filesystem because it "
+ echo -e "${FAILURE}could not be mounted"
+ echo -e "${FAILURE}in read-only mode.\n\n"
+ echo -e -n "${FAILURE}After you press Enter, this system will be "
+ echo -e "${FAILURE}halted and powered off.\n"
+ echo -e "${INFO}Press enter to continue...${NORMAL}"
+ $FAILURE_ACTION
+ /etc/rc.d/init.d/halt stop
+ fi
+
+ if [ -f /forcefsck ]
+ then
+ echo "${INFO}/forcefsck found!"
+ log_success_msg "${INFO}Forcing file system checks as requested."
+ options="-f"
+ else
+ options=""
+ fi
+
+ # Note: -a option used to be -p; but this fails e.g.
+ # on fsck.minix
+ fsck ${options} -a -A -C -T
+ error_value=${?}
+
+ if [ "${error_value}" -eq 0 ]
+ then
+ log_success_msg "Checking file systems..."
+ elif [ "${error_value}" -eq 1 ]
+ then
+ log_warning_msg "Checking file systems..."
+ echo -e "${WARNING}WARNING:\n"
+ echo -e "${WARNING}File system errors were found and have been"
+ echo -e "${WARNING}corrected. You may want to double-check that"
+ echo -e "${WARNING}everything was fixed properly.${NORMAL}"
+ elif [ "${error_value}" -eq 2 -o "${error_value}" -eq 3 ]; then
+ log_warning_msg "Checking file systems..."
+ echo -e "${WARNING}WARNING:\n"
+ echo -e "${WARNING}File system errors were found and have been been"
+ echo -e "${WARNING}corrected, but the nature of the errors require"
+ echo -e "${WARNING}this system to be rebooted.\n"
+ echo -e "After you press enter, this system will be rebooted.\n"
+ echo -e "${INFO}Press Enter to continue...${NORMAL}"
+ $FAILURE_ACTION
+ reboot -f
+ elif [ "${error_value}" -gt 3 -a "${error_value}" -lt 16 ]; then
+ log_failure_msg "Checking file systems..."
+ echo -e "${FAILURE}FAILURE:\n"
+ echo -e "${FAILURE}File system errors were encountered that could"
+ echo -e "${FAILURE}not be fixed automatically. This system cannot"
+ echo -e "${FAILURE}continue to boot and will therefore be halted"
+ echo -e "${FAILURE}until those errors are fixed manually by a"
+ echo -e "${FAILURE}System Administrator.\n"
+ echo -e "${FAILURE}After you press Enter, this system will be"
+ echo -e "${FAILURE}halted and powered off.\n"
+ echo -e "${INFO}Press Enter to continue...${NORMAL}"
+ $FAILURE_ACTION
+ /etc/rc.d/init.d/halt stop
+ elif [ "${error_value}" -ge 16 ]; then
+ log_failure_msg "Checking file systems..."
+ echo -e "${FAILURE}FAILURE:\n"
+ echo -e "${FAILURE}Unexpected Failure running fsck. Exited with error"
+ echo -e "${FAILURE}code: ${error_value}.${NORMAL}"
+ exit ${error_value}
+ fi
+ ;;
+ *)
+ echo "Usage: ${0} {start}"
+ exit 1
+ ;;
+esac
+
+# End /etc/init.d/checkfs